unit dmprint;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, memds, db, FileUtil, LR_Class, LR_DBSet;

type

  { TDataModulePrint }

  TDataModulePrint = class(TDataModule)
    DataSourceTest: TDataSource;
    frDBDataSet1: TfrDBDataSet;
    frReportMain: TfrReport;
    MemDatasetTest: TMemDataset;
    procedure DataModuleCreate(Sender: TObject);
  private
     function GetAppDir:String; { GetAppDir}
  public
     procedure AddTestValues; { TestValues for Report }
     procedure PrintReport(aPreview:Boolean);    { Printreport }
  end;

var
  DataModulePrint: TDataModulePrint;

implementation

{$R *.lfm}

function TDataModulePrint.GetAppDir:string;
begin
  Result := ExtractFilePath(ParamStr(0));
  {$IFDEF Darwin}
    Result := copy(Result,1,pos(ExtractFileName(ParamStr(0))+'.app/Contents/MacOS',Result)-1);
  {$ENDIF}
  Result := IncludeTrailingPathDelimiter(Result);
end;

procedure TDataModulePrint.DataModuleCreate(Sender: TObject);
begin
 AddTestValues;
end;

procedure TDataModulePrint.AddTestValues;
var
  i :integer;
begin
  with MemDatasetTest do
  begin
     if not Active then
      Open;
     for i:=0 to 30 do
     begin
        insert;
        FieldByName('T1').AsString := 'Test1 '+intToStr(i);
        FieldByName('T2').AsString := 'Test2 '+intToStr(i);
        Edit;
     end;
  end;
end;

procedure TDataModulePrint.PrintReport(aPreview:Boolean);
begin
 with frReportMain do
 begin
    LoadFromFile( GetAppDir+'macreport.lrf');
    if PrepareReport then
    begin
      if aPreview then
        ShowReport
      else
        PrintPreparedReport('',1);
    end;
 end;

end;

end.

